Index: eclaireXL_ITX/hdmi/scandoubler_hdmi.vhdl
===================================================================
--- eclaireXL_ITX/hdmi/scandoubler_hdmi.vhdl	(revision 973)
+++ eclaireXL_ITX/hdmi/scandoubler_hdmi.vhdl	(revision 974)
@@ -10,8 +10,13 @@
 use ieee.numeric_std.all;
 USE IEEE.STD_LOGIC_UNSIGNED.ALL;
 use IEEE.STD_LOGIC_MISC.all;
+use work.pixels.all;
 
 ENTITY scandoubler_hdmi IS
+GENERIC(
+	enable_area_scaler : integer;
+	enable_polyphasic_scaler : integer
+);
 PORT 
 ( 
 	-- Atari clock_domain
@@ -36,6 +41,7 @@
 	--HDMI clock domain
 	CLK_HDMI_IN : IN STD_LOGIC;   -- 135MHz exactly
 	CLK_PIXEL_IN : IN STD_LOGIC;  -- 27 MHz exactly (aligned with HDMI)
+	CLK_HDMI_SELECT : OUT STD_LOGIC_VECTOR(2 downto 0); 
 
 	-- VGA output - in clk pixel domain
 	O_hsync : out std_logic;
@@ -47,7 +53,11 @@
 
 	-- TO TV...
 	O_TMDS_H : OUT STD_LOGIC_VECTOR(7 downto 0);
-	O_TMDS_L : OUT STD_LOGIC_VECTOR(7 downto 0)
+	O_TMDS_L : OUT STD_LOGIC_VECTOR(7 downto 0);
+	
+	-- I2C params
+	scl : inout std_logic;
+	sda : inout std_logic
 );
 END scandoubler_hdmi;
 
@@ -57,12 +67,12 @@
 	PORT
 	(
 		data		: IN STD_LOGIC_VECTOR (7 DOWNTO 0);
-		rdaddress		: IN STD_LOGIC_VECTOR (12 DOWNTO 0);
+		rdaddress		: IN STD_LOGIC_VECTOR (10 DOWNTO 0);
 		rdclock		: IN STD_LOGIC ;
-		wraddress		: IN STD_LOGIC_VECTOR (12 DOWNTO 0);
+		wraddress		: IN STD_LOGIC_VECTOR (13 DOWNTO 0);
 		wrclock		: IN STD_LOGIC  := '1';
 		wren		: IN STD_LOGIC  := '0';
-		q		: OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
+		q		: OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
 	);
 END component;
 
@@ -71,9 +81,6 @@
 -- TODO: NTSC!
 -- ModeLine " 720x 480@59.94Hz"  27.00  720  736  798  858  480  489  495  525 -HSync -VSync
 
-signal hcnt		: std_logic_vector(11 downto 0) := "000000000000"; 	-- horizontal pixel counter
-signal vcnt		: std_logic_vector(11 downto 0) := "000000000000"; 	-- vertical line counter
-
 signal hsync_next		: std_logic;
 signal vsync_next		: std_logic;
 signal blank_next		: std_logic;
@@ -100,39 +107,69 @@
 signal hs_blue_reg2		: std_logic_vector(7 downto 4);
 
 --
-signal cap_vsync_shift_next : std_logic_vector(3 downto 0);
-signal cap_vsync_shift_reg : std_logic_vector(3 downto 0);
-signal cap_vcount_next : std_logic_vector(1 downto 0);
-signal cap_vcount_reg : std_logic_vector(1 downto 0);
+signal cap_vcount_next : std_logic_vector(2 downto 0);
+signal cap_vcount_reg : std_logic_vector(2 downto 0);
 signal cap_hcount_next : std_logic_vector(10 downto 0);
 signal cap_hcount_reg : std_logic_vector(10 downto 0);
 signal cap_vsync_reg : std_logic;
 signal cap_hsync_reg : std_logic;
-signal cap_frame_start : std_logic;
+signal cap_frame_start_flip_next : std_logic;
+signal cap_frame_start_flip_reg : std_logic;
 signal cap_line_start_raw : std_logic;
 signal cap_line_start : std_logic;
 signal cap_format : std_logic_vector(1 downto 0);
+signal cap_line_start_flip_next : std_logic;
+signal cap_line_start_flip_reg : std_logic;
+signal cap_vcount_delay_reg : std_logic_vector(14 downto 0);
+signal cap_vcount_delay_next : std_logic_vector(14 downto 0);
 
--- 
-signal out_colour_raw : std_logic_vector(7 downto 0);
-signal out_colour : std_logic_vector(7 downto 0);
+-- area scaling setup
+signal out_colour_raw_lines : std_logic_vector(63 downto 0);
+
+signal out_haddr_next : std_logic_vector(10 downto 0);
+signal out_haddr_reg : std_logic_vector(10 downto 0);
+
+signal out_vaddr_next : std_logic_vector(8 downto 0);
+signal out_vaddr_reg : std_logic_vector(8 downto 0);
+
+signal out_vaddr_in_next : std_logic_vector(8 downto 0);
+signal out_vaddr_in_reg : std_logic_vector(8 downto 0);
+
+signal out_pixels_next : t_Pixel4x4;
+signal out_pixels_reg : t_Pixel4x4;
+
+signal out_next_x : std_logic;
+signal out_next_x_reg : std_logic;
+signal out_next_x_size : std_logic_vector(1 downto 0);
+signal out_next_y : std_logic;
+
+-- crtc
+signal crtc_inc_line : std_logic;
+signal crtc_inc_frame : std_logic;
+signal crtc_hsync : std_logic;
+signal crtc_vsync : std_logic;
+signal crtc_blank : std_logic;
+signal crtc_field2 : std_logic;
+signal crtc_video_id_code : std_logic_vector(7 downto 0);
+signal crtc_scaler_select : std_logic;
+
+signal out_resync_required_reg : std_logic;
+signal out_resync_required_next : std_logic;
+
+--signal out_colour_raw : std_logic_vector(7 downto 0);
+signal out_colour : std_logic_vector(31 downto 0);
 signal out_pal : std_logic;
 signal out_scanlines : std_logic;
 signal out_csync : std_logic;
+signal out_frame_start_flip_next : std_logic;
+signal out_frame_start_flip_reg : std_logic;
 signal out_frame_start : std_logic;
+signal out_line_start_flip_next : std_logic;
+signal out_line_start_flip_reg : std_logic;
+signal out_line_start : std_logic;
+signal out_resync_frame_start : std_logic;
 signal out_format : std_logic_vector(1 downto 0);
 
--- Horizontal Timing   
-signal h_pixels_across	: integer;
-signal h_sync_on		: integer;
-signal h_sync_off		: integer;
-signal h_end_count		: integer;
--- Vertical Timing 
-signal v_pixels_down		: integer;
-signal v_sync_on		: integer;
-signal v_sync_off		: integer;
-signal v_end_count		: integer;
-
 -- signed audio
 signal audio_left_signed : std_logic_vector(15 downto 0);
 signal audio_right_signed: std_logic_vector(15 downto 0);
@@ -158,12 +195,23 @@
 signal encoded_green_reg : std_logic_vector(9 downto 0);
 signal encoded_blue_reg  : std_logic_vector(9 downto 0);
 
-signal mod5	: std_logic_vector(2 downto 0) := "000";	-- modulus 5 counter
-signal shift_r	: std_logic_vector(9 downto 0) := "0000000000";
-signal shift_g	: std_logic_vector(9 downto 0) := "0000000000";
-signal shift_b	: std_logic_vector(9 downto 0) := "0000000000";
-signal shift_clk : std_logic_vector(9 downto 0) := "0000000000";
+-- fast regs
+signal mod5_reg	: std_logic_vector(4 downto 0) := "00000";	-- modulus 5 counter
+signal mod5_next	: std_logic_vector(4 downto 0) := "00000";	-- modulus 5 counter
+signal shift_r_reg	: std_logic_vector(9 downto 0) := "0000000000";
+signal shift_g_reg	: std_logic_vector(9 downto 0) := "0000000000";
+signal shift_b_reg	: std_logic_vector(9 downto 0) := "0000000000";
+signal shift_clk_reg : std_logic_vector(9 downto 0) := "0000000000";
 
+signal nshift_r_reg	: std_logic_vector(9 downto 0) := "0000000000";
+signal nshift_g_reg	: std_logic_vector(9 downto 0) := "0000000000";
+signal nshift_b_reg	: std_logic_vector(9 downto 0) := "0000000000";
+signal nshift_clk_reg : std_logic_vector(9 downto 0) := "0000000000";	
+
+signal shift_r_next	: std_logic_vector(9 downto 0) := "0000000000";
+signal shift_g_next	: std_logic_vector(9 downto 0) := "0000000000";
+signal shift_b_next	: std_logic_vector(9 downto 0) := "0000000000";	
+signal shift_clk_next : std_logic_vector(9 downto 0) := "0000000000";
 	
 BEGIN
 
@@ -179,13 +227,17 @@
 		cap_vcount_reg <= (others=>'0');
 		cap_vsync_reg <= '0';
 		cap_hsync_reg <= '0';
-		cap_vsync_shift_reg <= (others=>'0');
+		cap_line_start_flip_reg <= '0';
+		cap_frame_start_flip_reg <= '0';
+		cap_vcount_delay_reg <= (others=>'0');
 	elsif (CLK_ATARI_IN'event and CLK_ATARI_IN='1') then
 		cap_hcount_reg <= cap_hcount_next;
 		cap_vcount_reg <= cap_vcount_next;
 		cap_vsync_reg <= vsync_in;
 		cap_hsync_reg <= hsync_in;
-		cap_vsync_shift_reg <= cap_vsync_shift_next;
+		cap_line_start_flip_reg <= cap_line_start_flip_next;
+		cap_frame_start_flip_reg <= cap_frame_start_flip_next;
+		cap_vcount_delay_reg <= cap_vcount_delay_next;
 	end if;
 end process;
 
@@ -192,7 +244,7 @@
 cap_line_start_raw <= not(hsync_in) and cap_hsync_reg;
 hsync_delay : entity work.delay_line
 	generic map (COUNT=>184)
-	port map(clk=>clk_atari_in,sync_reset=>'0',data_in=>cap_line_start_raw,enable=>colour_enable,reset_n=>'1',data_out=>cap_line_start);			
+	port map(clk=>clk_atari_in,sync_reset=>'0',data_in=>cap_line_start_raw,enable=>colour_enable,reset_n=>'1',data_out=>cap_line_start);				
 
 -- our location
 process(cap_hcount_reg, colour_enable, cap_line_start)
@@ -214,35 +266,48 @@
 	end if;
 end process;
 
-process(cap_vcount_reg, cap_line_start, cap_vsync_reg, vsync_in, cap_vsync_shift_reg)
+process(cap_vcount_reg, cap_line_start, cap_vsync_reg, vsync_in, cap_frame_start_flip_reg, cap_line_start_flip_reg, cap_vcount_delay_reg)
 begin
 	cap_vcount_next <= cap_vcount_reg;
-	cap_vsync_shift_next <= cap_vsync_shift_reg;
+	cap_frame_start_flip_next <= cap_frame_start_flip_reg;
+	cap_line_start_flip_next <= cap_line_start_flip_reg;
+	cap_vcount_delay_next <= cap_vcount_delay_reg;
+	
 	if (cap_line_start = '1') then
 		cap_vcount_next <= std_logic_vector(unsigned(cap_vcount_reg)+1);
-		cap_vsync_shift_next <= cap_vsync_shift_reg(2 downto 0)&'0';
+		cap_line_start_flip_next <= not(cap_line_start_flip_reg);		
+		
+		cap_vcount_delay_next(14 downto 0) <= cap_vcount_delay_reg(13 downto 0)&'0';
+		
+		if (cap_vcount_delay_reg(14) = '1') then		
+			cap_vcount_next <= (others=>'0');		
+			cap_frame_start_flip_next <= not(cap_frame_start_flip_reg);		
+		end if;
 	end if;
+	
 	if (cap_vsync_reg = '1' and vsync_in = '0') then
-		cap_vcount_next <= (others=>'0');
-		cap_vsync_shift_next <= "0001";
+		cap_vcount_delay_next(0) <= '1';
 	end if;
 end process;
 
-cap_frame_start <= cap_vsync_shift_reg(2);
-
 hdmi_line_buffer_inst : hdmi_line_buffer
 port map 
 	(
-		data		=> colour_in and colour_mask,
-		wraddress	=> cap_vcount_reg&cap_hcount_reg,
+		-- 8 bit write
+		-- 4 lines
+		-- low bit is line, so we can read all lines at once
+		data		=> colour_in and colour_mask, --"00000"&cap_vcount_reg(2 downto 0),
+		--data		=> "0000"&cap_hcount_reg(3 downto 0),
+		--data		=> "0000"&cap_hcount_reg(0 downto 0)&"000",
+		wraddress	=> cap_hcount_reg&cap_vcount_reg,
 		wrclock		=> CLK_ATARI_IN,
 		wren		=> colour_enable, -- 1824 times/line
 
-		rdaddress	=> vcnt(2 downto 1)&hcnt(9 downto 0)&'0',
+		-- 32 bit read (to read all lines at once!)
+		rdaddress	=> out_haddr_next,
 		rdclock		=> CLK_PIXEL_IN,
-		q		=> out_colour_raw
+		q		=> out_colour_raw_lines
 	);
-
 -- Audio should be signed
 
 audio_left_signed  <= std_logic_vector(to_signed(to_integer(unsigned(audio_left))-32768,16));
@@ -262,73 +327,208 @@
 	port map (clk=>clk_pixel_in, raw=>csync_on, sync=>out_csync);						
 
 cap_vsync_synchronizer : entity work.synchronizer
-	port map (clk=>clk_pixel_in, raw=>cap_frame_start, sync=>out_frame_start);						
+	port map (clk=>clk_pixel_in, raw=>cap_frame_start_flip_reg, sync=>out_frame_start_flip_next);			
+cap_hsync_synchronizer : entity work.synchronizer
+	port map (clk=>clk_pixel_in, raw=>cap_line_start_flip_reg, sync=>out_line_start_flip_next);
+	
 cap_format0_synchronizer : entity work.synchronizer
 	port map (clk=>clk_pixel_in, raw=>format(0), sync=>out_format(0));						
 cap_format1_synchronizer : entity work.synchronizer
 	port map (clk=>clk_pixel_in, raw=>format(1), sync=>out_format(1));						
 
-out_colour(7 downto 4) <= out_colour_raw(7 downto 4);
-out_colour(3 downto 0) <= out_colour_raw(3 downto 0) when (not(out_scanlines) or vcnt(0))='1' else '0'&out_colour_raw(3 downto 1);
+process(out_colour_raw_lines,out_vaddr_reg)
+begin
+	out_colour <= (others=>'0');
 
--- colour palette
--- TODO- share!!
-palette4 : entity work.gtia_palette
-	port map (PAL=>out_pal,ATARI_COLOUR=>out_colour, R_next=>red_next, G_next=>green_next, B_next=>blue_next);		
-	
--- extract from fifo to line buffer (720 pixels)
--- sync vsync between sides...
+	case out_vaddr_reg(2 downto 0) is
+	when "000" => 
+		out_colour <= out_colour_raw_lines(31 downto 0);
+	when "001" => 
+		out_colour <= out_colour_raw_lines(39 downto 8);
+	when "010" => 
+		out_colour <= out_colour_raw_lines(47 downto 16);
+	when "011" => 
+		out_colour <= out_colour_raw_lines(55 downto 24);
+	when "100" => 
+		out_colour <= out_colour_raw_lines(63 downto 32);
+	when "101" => 
+		out_colour(23 downto 0) <= out_colour_raw_lines(63 downto 40);
+		out_colour(31 downto 24) <= out_colour_raw_lines(7 downto 0);
+	when "110" => 
+		out_colour(15 downto 0) <= out_colour_raw_lines(63 downto 48);
+		out_colour(31 downto 16) <= out_colour_raw_lines(15 downto 0);
+	when "111" => 
+		out_colour(7 downto 0) <= out_colour_raw_lines(63 downto 56);		
+		out_colour(31 downto 8) <= out_colour_raw_lines(23 downto 0);
+	end case;
+end process;
 
-process (clk_pixel_in, hcnt, out_frame_start)
+--1 2
+--3 4
+-- shift pixels, when next requested
+-- moving to the right
+process(crtc_inc_line, out_next_x, out_next_x_size, out_haddr_reg)
 begin
-	if clk_pixel_in'event and clk_pixel_in = '1' then
-		if hcnt = h_end_count then
-			hcnt <= (others => '0');
-		else
-			hcnt <= hcnt + 1;
-		end if;
-		if hcnt = h_sync_on then
-			if (vcnt = v_end_count) then
-				vcnt <= (others => '0');
-			else
-				vcnt <= vcnt + 1;
-			end if;
-		end if;
+	out_haddr_next <= out_haddr_reg;
 
-		if (out_frame_start='1' and (vcnt <= (v_sync_off-4) or vcnt >= (v_sync_off+4))) then
-			vcnt <= std_logic_vector(to_unsigned(v_sync_off,12));
-		end if;
+	if (out_next_x='1') then
+		out_haddr_next <= std_logic_vector(unsigned(out_haddr_reg) + unsigned(out_next_x_size)); --read next address, next cycle
 	end if;
+
+	if (crtc_inc_line='1') then
+		out_haddr_next <= (others=>'0') ; --"00000000100"; --param?
+	end if;
 end process;
 
-hsync_next	<= '0' when (hcnt <= h_sync_on) or (hcnt > h_sync_off) else '1';
-vsync_next	<= '0' when (vcnt <= v_sync_on) or (vcnt > v_sync_off) else '1';
-blank_next	<= '1' when (hcnt > h_pixels_across) or (vcnt > v_pixels_down) else '0';
+process(out_pixels_reg, out_next_x_reg,crtc_inc_line)
+begin
+	for i in 0 to 2 loop
+		for j in 0 to 3 loop
+				out_pixels_next(pixel4x4_idx(i,j)) <= out_pixels_reg(pixel4x4_idx(i,j));
+		end loop;
+	end loop;
+	--out_pixels_next(0 to 2,0 to 3,0 to 2) <= out_pixels_reg(0 to 2,0 to 3,0 to 2);
 
--- TODO -- allow ZPU to write these - simple CRTC!
-process(out_pal)
+	if (out_next_x_reg='1') then		
+		for i in 0 to 2 loop
+			for j in 0 to 3 loop
+					out_pixels_next(pixel4x4_idx(i,j)) <= out_pixels_reg(pixel4x4_idx(i+1,j));
+			end loop;
+		end loop;		
+		--out_pixels_next(0 to 2,0 to 3,0 to 2) <= out_pixels_reg(1 to 3,0 to 3,0 to 2);
+	end if;
+
+	if (crtc_inc_line='1') then
+		for i in 0 to 2 loop
+			for j in 0 to 3 loop
+				out_pixels_next(pixel4x4_idx(i,j)).red <= x"00";
+				out_pixels_next(pixel4x4_idx(i,j)).green <= x"00";
+				out_pixels_next(pixel4x4_idx(i,j)).blue <= x"00";
+			end loop;
+		end loop;			
+		--out_pixels_next(0 to 2,0 to 3,0 to 2) <= (others=>'0');
+	end if;
+end process;
+
+process(out_next_y, out_vaddr_reg, crtc_inc_frame)
 begin
-	if (out_pal = '1') then
-		h_pixels_across	 <= 720 - 1;
-		h_sync_on <= 732 - 1;
-		h_sync_off <= 795 - 1;
-		h_end_count <= 864 - 1;
-		v_pixels_down <= 576 - 1;
-		v_sync_on <=  581 - 1;
-		v_sync_off <= 586 - 1;
-		v_end_count <=  625 - 1;
-	else
-		h_pixels_across	 <= 720 - 1;
-		h_sync_on <= 736 -1;
-		h_sync_off <= 798 -1;
-		h_end_count <= 858 -1;
-		v_pixels_down <= 480 -1;
-		v_sync_on <=  489 -1;
-		v_sync_off <= 495 -1;
-		v_end_count <=  525 -1;
+	out_vaddr_next <= out_vaddr_reg;
+
+	if (out_next_y='1') then
+		out_vaddr_next <= out_vaddr_reg + 1; 
 	end if;
+
+	if (crtc_inc_frame='1') then
+		out_vaddr_next <= (others=>'0');
+	end if;
 end process;
 
+-- colour palette
+-- TODO- share!!
+palette4 : entity work.gtia_palette
+	port map (PAL=>out_pal,ATARI_COLOUR=>out_colour(7 downto 0), R_next=>out_pixels_next(pixel4x4_idx(3,0)).red, G_next=>out_pixels_next(pixel4x4_idx(3,0)).green, B_next=>out_pixels_next(pixel4x4_idx(3,0)).blue);		
+palette5 : entity work.gtia_palette
+	port map (PAL=>out_pal,ATARI_COLOUR=>out_colour(15 downto 8), R_next=>out_pixels_next(pixel4x4_idx(3,1)).red, G_next=>out_pixels_next(pixel4x4_idx(3,1)).green, B_next=>out_pixels_next(pixel4x4_idx(3,1)).blue);		
+palette6 : entity work.gtia_palette
+	port map (PAL=>out_pal,ATARI_COLOUR=>out_colour(23 downto 16), R_next=>out_pixels_next(pixel4x4_idx(3,2)).red, G_next=>out_pixels_next(pixel4x4_idx(3,2)).green, B_next=>out_pixels_next(pixel4x4_idx(3,2)).blue);		
+palette7 : entity work.gtia_palette
+	port map (PAL=>out_pal,ATARI_COLOUR=>out_colour(31 downto 24), R_next=>out_pixels_next(pixel4x4_idx(3,3)).red, G_next=>out_pixels_next(pixel4x4_idx(3,3)).green, B_next=>out_pixels_next(pixel4x4_idx(3,3)).blue);			
+
+multiscale_impl : entity work.multiscale
+	generic map(
+		enable_area => enable_area_scaler,
+		enable_polyphasic => enable_polyphasic_scaler
+   )
+	port map 
+	(
+		CLOCK => clk_pixel_in,
+		RESET_N => reset_n,
+		
+		scaler_select => crtc_scaler_select,
+
+		pixels => out_pixels_reg,
+		next_y_in => crtc_inc_line,      --reset_x
+		next_frame_in => crtc_inc_frame, --reset y
+		next_x => out_next_x,
+		next_y => out_next_y,
+		next_x_size => out_next_x_size,
+		field2 => crtc_field2, -- field 2 is half lower
+		
+		hsync_in => crtc_hsync,
+		vsync_in => crtc_vsync,
+		blank_in => crtc_blank,
+
+		r => red_next,
+		g => green_next,
+		b => blue_next,
+		hsync => hsync_next,
+		vsync => vsync_next,
+		blank => blank_next,
+				
+		sda => sda,
+		scl => scl		
+	);	
+
+-- Resynchronization logic
+-- Compare what is in line buffer, with what we are reading	
+	out_frame_start <= out_frame_start_flip_reg xor out_frame_start_flip_next;
+	out_line_start <= out_line_start_flip_reg xor out_line_start_flip_next;
+
+	process(out_vaddr_in_reg, out_frame_start, out_line_start)
+	begin
+		out_vaddr_in_next <= out_vaddr_in_reg;
+
+		if (out_frame_start='1') then
+			out_vaddr_in_next <= (others=>'0');		
+		elsif (out_line_start='1') then
+			out_vaddr_in_next <= out_vaddr_in_reg+1;
+		end if;
+	end process;	
+	
+	process(out_frame_start,out_resync_required_reg,out_vaddr_in_reg,out_vaddr_reg)		
+		variable lowerbound : std_logic_vector(8 downto 0);
+		variable upperbound : std_logic_vector(8 downto 0);
+	begin		
+		out_resync_required_next <= out_resync_required_reg;
+		out_resync_frame_start <= '0';			
+		
+		lowerbound := out_vaddr_in_reg-7;
+		upperbound := out_vaddr_in_reg-4;
+		
+		if (not(out_vaddr_reg>=lowerbound and out_vaddr_reg<=upperbound) and or_reduce(out_vaddr_reg(7 downto 3))='1' and or_reduce(out_vaddr_in_reg(7 downto 3))='1') then
+			out_resync_required_next <= '1';
+		end if;
+		
+		if (out_resync_required_reg='1' and out_vaddr_in_reg="00000110") then
+			out_resync_required_next <= '0';
+			out_resync_frame_start <= '1';
+		end if;	
+	end process;
+
+crtc_impl : entity work.crtc
+	port map
+	(
+		clk_pixel => clk_pixel_in,
+		reset_n => reset_n,
+
+		resync_start_frame => out_resync_frame_start,
+
+		hsync => crtc_hsync,
+		vsync => crtc_vsync,
+		blank => crtc_blank,
+
+		inc_line => crtc_inc_line,
+		inc_frame => crtc_inc_frame,
+		field2 => crtc_field2, -- field 2 is half lower		
+
+		clock_select => clk_hdmi_select,
+		video_id_code => crtc_video_id_code,
+		scaler_select => crtc_scaler_select,
+
+		sda => sda,
+		scl => scl
+	);
+
 hdmiav_inst : entity work.hdmi
 port map (
 	I_CLK_PIXEL => clk_pixel_in,
@@ -341,6 +541,7 @@
 	I_R		=> red_reg,
 	I_G		=> green_reg,
 	I_B		=> blue_reg,
+	I_VIDEO_ID_CODE => crtc_video_id_code,
 	O_R	=> hdmi_encoded_red,
 	O_G	=> hdmi_encoded_green,
 	O_B	=> hdmi_encoded_blue);
@@ -381,25 +582,48 @@
 	end case;
 end process;
 
-process (CLK_HDMI_IN)
+process (CLK_HDMI_IN,RESET_N)
 begin
-	if (CLK_HDMI_IN'event and CLK_HDMI_IN = '1') then
-		if mod5(2) = '1' then
-			mod5 <= "000";
-			shift_r <= encoded_red_reg;
-			shift_g <= encoded_green_reg;
-			shift_b <= encoded_blue_reg;
-			shift_clk <= "0000011111";
-		else
-			mod5 <= mod5 + "001";
-			shift_r <= "00" & shift_r(9 downto 2);
-			shift_g <= "00" & shift_g(9 downto 2);
-			shift_b <= "00" & shift_b(9 downto 2);
-			shift_clk <= "00" & shift_clk(9 downto 2);
-		end if;
+	if (RESET_N='0') then
+		mod5_reg <= "00001";
+		shift_r_reg <= (others=>'0');
+		shift_g_reg <= (others=>'0');
+		shift_b_reg <= (others=>'0');
+		shift_clk_reg <= (others=>'0');
+		nshift_r_reg <= (others=>'0');
+		nshift_g_reg <= (others=>'0');
+		nshift_b_reg <= (others=>'0');
+		nshift_clk_reg <= (others=>'0');
+	elsif (CLK_HDMI_IN'event and CLK_HDMI_IN = '1') then
+		mod5_reg <= mod5_next;
+		shift_r_reg <= shift_r_next;
+		shift_g_reg <= shift_g_next;
+		shift_b_reg <= shift_b_next;
+		shift_clk_reg <= shift_clk_next;
+		nshift_r_reg <= not(shift_r_next);
+		nshift_g_reg <= not(shift_g_next);
+		nshift_b_reg <= not(shift_b_next);
+		nshift_clk_reg <= not(shift_clk_next);
 	end if;
 end process;
+	
+process(encoded_red_reg,encoded_green_reg,encoded_blue_reg,shift_r_reg,shift_g_reg,shift_b_reg,mod5_reg,shift_clk_reg)
+begin		
+	mod5_next <= mod5_reg(3 downto 0)&mod5_reg(4);
 
+	if mod5_reg(0) = '1' then			
+		shift_r_next <= encoded_red_reg;
+		shift_g_next <= encoded_green_reg;
+		shift_b_next <= encoded_blue_reg;
+		shift_clk_next <= "0000011111";
+	else
+		shift_r_next <= "00" & shift_r_reg(9 downto 2);
+		shift_g_next <= "00" & shift_g_reg(9 downto 2);
+		shift_b_next <= "00" & shift_b_reg(9 downto 2);
+		shift_clk_next <= "00" & shift_clk_reg(9 downto 2);
+	end if;		
+end process;
+	
 
 process(clk_pixel_in)
 begin
@@ -409,6 +633,18 @@
 		audio_right_reg1 <= audio_right_signed;
 		audio_right_reg2 <= audio_right_reg1;
 
+		out_haddr_reg <= out_haddr_next;
+		out_vaddr_reg <= out_vaddr_next;
+		out_vaddr_in_reg <= out_vaddr_in_next;
+
+		out_pixels_reg <= out_pixels_next;
+		out_next_x_reg <= out_next_x;
+
+		out_frame_start_flip_reg <= out_frame_start_flip_next;
+		out_line_start_flip_reg <= out_line_start_flip_next;
+		
+		out_resync_required_reg <= out_resync_required_next;
+		
 		hsync_reg <= hsync_next;
 		vsync_reg <= vsync_next;
 		blank_reg <= blank_next;
@@ -457,10 +693,9 @@
 O_blue <= hs_blue_reg2(7 downto 4)&hs_blue_reg(3 downto 0);
 
 -- TMDS outputs - with specified timings
-O_TMDS_H <= shift_r(0) & not(shift_r(0)) & shift_g(0) & not(shift_g(0)) & shift_b(0) & not(shift_b(0)) & shift_clk(0) & not(shift_clk(0));
-O_TMDS_L <= shift_r(1) & not(shift_r(1)) & shift_g(1) & not(shift_g(1)) & shift_b(1) & not(shift_b(1)) & shift_clk(1) & not(shift_clk(1));
+O_TMDS_H <= shift_r_reg(0) & nshift_r_reg(0) & shift_g_reg(0) & nshift_g_reg(0) & shift_b_reg(0) & nshift_b_reg(0) & shift_clk_reg(0) & nshift_clk_reg(0);
+O_TMDS_L <= shift_r_reg(1) & nshift_r_reg(1) & shift_g_reg(1) & nshift_g_reg(1) & shift_b_reg(1) & nshift_b_reg(1) & shift_clk_reg(1) & nshift_clk_reg(1);
 
-
 end vhdl;
 
 
Index: eclaireXL_ITX/pll_hdmi/pll_hdmi_0002.qip
===================================================================
--- eclaireXL_ITX/pll_hdmi/pll_hdmi_0002.qip	(revision 973)
+++ eclaireXL_ITX/pll_hdmi/pll_hdmi_0002.qip	(revision 974)
@@ -1,4 +1,4 @@
 set_instance_assignment -name PLL_COMPENSATION_MODE NORMAL -to "*pll_hdmi_0002*|altera_pll:altera_pll_i*|*"
  
-set_instance_assignment -name PLL_AUTO_RESET OFF -to "*pll_hdmi_0002*|altera_pll:altera_pll_i*|*"
+set_instance_assignment -name PLL_AUTO_RESET ON -to "*pll_hdmi_0002*|altera_pll:altera_pll_i*|*"
 set_instance_assignment -name PLL_BANDWIDTH_PRESET AUTO -to "*pll_hdmi_0002*|altera_pll:altera_pll_i*|*"
Index: eclaireXL_ITX/pll_hdmi/pll_hdmi_0002.v
===================================================================
--- eclaireXL_ITX/pll_hdmi/pll_hdmi_0002.v	(revision 973)
+++ eclaireXL_ITX/pll_hdmi/pll_hdmi_0002.v	(revision 974)
@@ -10,9 +10,6 @@
 	// interface 'outclk0'
 	output wire outclk_0,
 
-	// interface 'outclk1'
-	output wire outclk_1,
-
 	// interface 'locked'
 	output wire locked
 );
@@ -19,13 +16,13 @@
 
 	altera_pll #(
 		.fractional_vco_multiplier("false"),
-		.reference_clock_frequency("50.0 MHz"),
+		.reference_clock_frequency("54.0 MHz"),
 		.operation_mode("normal"),
-		.number_of_clocks(2),
-		.output_clock_frequency0("27.000000 MHz"),
+		.number_of_clocks(1),
+		.output_clock_frequency0("148.500000 MHz"),
 		.phase_shift0("0 ps"),
 		.duty_cycle0(50),
-		.output_clock_frequency1("135.000000 MHz"),
+		.output_clock_frequency1("0 MHz"),
 		.phase_shift1("0 ps"),
 		.duty_cycle1(50),
 		.output_clock_frequency2("0 MHz"),
@@ -80,7 +77,7 @@
 		.pll_subtype("General")
 	) altera_pll_i (
 		.rst	(rst),
-		.outclk	({outclk_1, outclk_0}),
+		.outclk	({outclk_0}),
 		.locked	(locked),
 		.fboutclk	( ),
 		.fbclk	(1'b0),
Index: eclaireXL_ITX/pll_hdmi.bsf
===================================================================
--- eclaireXL_ITX/pll_hdmi.bsf	(revision 973)
+++ eclaireXL_ITX/pll_hdmi.bsf	(revision 974)
@@ -4,7 +4,7 @@
 the Block Editor! File corruption is VERY likely to occur.
 */
 /*
-Copyright (C) 2016  Intel Corporation. All rights reserved.
+Copyright (C) 2018  Intel Corporation. All rights reserved.
 Your use of Intel Corporation's design tools, logic functions 
 and other software and tools, and its AMPP partner logic 
 functions, and any output files from any of the foregoing 
@@ -12,18 +12,17 @@
 associated documentation or information are expressly subject 
 to the terms and conditions of the Intel Program License 
 Subscription Agreement, the Intel Quartus Prime License Agreement,
-the Intel MegaCore Function License Agreement, or other 
-applicable license agreement, including, without limitation, 
-that your use is for the sole purpose of programming logic 
-devices manufactured by Intel and sold by Intel or its 
-authorized distributors.  Please refer to the applicable 
-agreement for further details.
+the Intel FPGA IP License Agreement, or other applicable license
+agreement, including, without limitation, that your use is for
+the sole purpose of programming logic devices manufactured by
+Intel and sold by Intel or its authorized distributors.  Please
+refer to the applicable agreement for further details.
 */
 (header "symbol" (version "1.1"))
 (symbol
-	(rect 0 0 160 184)
+	(rect 0 0 160 144)
 	(text "pll_hdmi" (rect 56 -1 87 11)(font "Arial" (font_size 10)))
-	(text "inst" (rect 8 168 20 180)(font "Arial" ))
+	(text "inst" (rect 8 128 20 140)(font "Arial" ))
 	(port
 		(pt 0 72)
 		(input)
@@ -48,17 +47,10 @@
 	(port
 		(pt 160 112)
 		(output)
-		(text "outclk_1" (rect 0 0 31 12)(font "Arial" (font_size 8)))
-		(text "outclk_1" (rect 119 101 167 112)(font "Arial" (font_size 8)))
+		(text "locked" (rect 0 0 24 12)(font "Arial" (font_size 8)))
+		(text "locked" (rect 127 101 163 112)(font "Arial" (font_size 8)))
 		(line (pt 160 112)(pt 112 112)(line_width 1))
 	)
-	(port
-		(pt 160 152)
-		(output)
-		(text "locked" (rect 0 0 24 12)(font "Arial" (font_size 8)))
-		(text "locked" (rect 127 141 163 152)(font "Arial" (font_size 8)))
-		(line (pt 160 152)(pt 112 152)(line_width 1))
-	)
 	(drawing
 		(text "refclk" (rect 16 43 68 99)(font "Arial" (color 128 0 0)(font_size 9)))
 		(text "clk" (rect 53 67 124 144)(font "Arial" (color 0 0 0)))
@@ -66,15 +58,13 @@
 		(text "reset" (rect 53 107 136 224)(font "Arial" (color 0 0 0)))
 		(text "outclk0" (rect 113 43 268 99)(font "Arial" (color 128 0 0)(font_size 9)))
 		(text "clk" (rect 97 67 212 144)(font "Arial" (color 0 0 0)))
-		(text "outclk1" (rect 113 83 268 179)(font "Arial" (color 128 0 0)(font_size 9)))
-		(text "clk" (rect 97 107 212 224)(font "Arial" (color 0 0 0)))
-		(text "locked" (rect 113 123 262 259)(font "Arial" (color 128 0 0)(font_size 9)))
-		(text "export" (rect 82 147 200 304)(font "Arial" (color 0 0 0)))
-		(text " altera_pll " (rect 118 168 308 346)(font "Arial" ))
+		(text "locked" (rect 113 83 262 179)(font "Arial" (color 128 0 0)(font_size 9)))
+		(text "export" (rect 82 107 200 224)(font "Arial" (color 0 0 0)))
+		(text " altera_pll " (rect 118 128 308 266)(font "Arial" ))
 		(line (pt 48 32)(pt 112 32)(line_width 1))
-		(line (pt 112 32)(pt 112 168)(line_width 1))
-		(line (pt 48 168)(pt 112 168)(line_width 1))
-		(line (pt 48 32)(pt 48 168)(line_width 1))
+		(line (pt 112 32)(pt 112 128)(line_width 1))
+		(line (pt 48 128)(pt 112 128)(line_width 1))
+		(line (pt 48 32)(pt 48 128)(line_width 1))
 		(line (pt 49 52)(pt 49 76)(line_width 1))
 		(line (pt 50 52)(pt 50 76)(line_width 1))
 		(line (pt 49 92)(pt 49 116)(line_width 1))
@@ -83,11 +73,9 @@
 		(line (pt 110 52)(pt 110 76)(line_width 1))
 		(line (pt 111 92)(pt 111 116)(line_width 1))
 		(line (pt 110 92)(pt 110 116)(line_width 1))
-		(line (pt 111 132)(pt 111 156)(line_width 1))
-		(line (pt 110 132)(pt 110 156)(line_width 1))
 		(line (pt 0 0)(pt 160 0)(line_width 1))
-		(line (pt 160 0)(pt 160 184)(line_width 1))
-		(line (pt 0 184)(pt 160 184)(line_width 1))
-		(line (pt 0 0)(pt 0 184)(line_width 1))
+		(line (pt 160 0)(pt 160 144)(line_width 1))
+		(line (pt 0 144)(pt 160 144)(line_width 1))
+		(line (pt 0 0)(pt 0 144)(line_width 1))
 	)
 )
Index: eclaireXL_ITX/pll_hdmi.ppf
===================================================================
--- eclaireXL_ITX/pll_hdmi.ppf	(revision 973)
+++ eclaireXL_ITX/pll_hdmi.ppf	(revision 974)
@@ -8,7 +8,6 @@
   <pin name="refclk" direction="input" scope="external" />
   <pin name="rst" direction="input" scope="external" />
   <pin name="outclk_0" direction="output" scope="external" />
-  <pin name="outclk_1" direction="output" scope="external" />
   <pin name="locked" direction="output" scope="external" />
  </global>
 </pinplan>
Index: eclaireXL_ITX/pll_hdmi.sip
===================================================================
--- eclaireXL_ITX/pll_hdmi.sip	(revision 973)
+++ eclaireXL_ITX/pll_hdmi.sip	(revision 974)
@@ -1,5 +1,5 @@
 set_global_assignment -entity "pll_hdmi" -library "lib_pll_hdmi" -name IP_TOOL_NAME "altera_pll"
-set_global_assignment -entity "pll_hdmi" -library "lib_pll_hdmi" -name IP_TOOL_VERSION "16.1"
+set_global_assignment -entity "pll_hdmi" -library "lib_pll_hdmi" -name IP_TOOL_VERSION "18.0"
 set_global_assignment -entity "pll_hdmi" -library "lib_pll_hdmi" -name IP_TOOL_ENV "mwpim"
 set_global_assignment -library "lib_pll_hdmi" -name SPD_FILE [file join $::quartus(sip_path) "pll_hdmi.spd"]
 
Index: eclaireXL_ITX/pll_hdmi2/pll_hdmi2_0002.qip
===================================================================
--- eclaireXL_ITX/pll_hdmi2/pll_hdmi2_0002.qip	(nonexistent)
+++ eclaireXL_ITX/pll_hdmi2/pll_hdmi2_0002.qip	(revision 974)
@@ -0,0 +1,4 @@
+set_instance_assignment -name PLL_COMPENSATION_MODE DIRECT -to "*pll_hdmi2_0002*|altera_pll:altera_pll_i*|*"
+ 
+set_instance_assignment -name PLL_AUTO_RESET ON -to "*pll_hdmi2_0002*|altera_pll:altera_pll_i*|*"
+set_instance_assignment -name PLL_BANDWIDTH_PRESET AUTO -to "*pll_hdmi2_0002*|altera_pll:altera_pll_i*|*"
Index: eclaireXL_ITX/pll_hdmi2_sim/cadence/cds.lib
===================================================================
--- eclaireXL_ITX/pll_hdmi2_sim/cadence/cds.lib	(nonexistent)
+++ eclaireXL_ITX/pll_hdmi2_sim/cadence/cds.lib	(revision 974)
@@ -0,0 +1,17 @@
+
+DEFINE std            $CDS_ROOT/tools/inca/files/STD/           
+DEFINE synopsys       $CDS_ROOT/tools/inca/files/SYNOPSYS/      
+DEFINE ieee           $CDS_ROOT/tools/inca/files/IEEE/          
+DEFINE ambit          $CDS_ROOT/tools/inca/files/AMBIT/         
+DEFINE vital_memory   $CDS_ROOT/tools/inca/files/VITAL_MEMORY/  
+DEFINE ncutils        $CDS_ROOT/tools/inca/files/NCUTILS/       
+DEFINE ncinternal     $CDS_ROOT/tools/inca/files/NCINTERNAL/    
+DEFINE ncmodels       $CDS_ROOT/tools/inca/files/NCMODELS/      
+DEFINE cds_assertions $CDS_ROOT/tools/inca/files/CDS_ASSERTIONS/
+DEFINE work           ./libraries/work/                         
+DEFINE altera         ./libraries/altera/                       
+DEFINE lpm            ./libraries/lpm/                          
+DEFINE sgate          ./libraries/sgate/                        
+DEFINE altera_mf      ./libraries/altera_mf/                    
+DEFINE altera_lnsim   ./libraries/altera_lnsim/                 
+DEFINE cyclonev       ./libraries/cyclonev/                     
